<template>
  <el-main>
    <el-row type="flex" justify="end">
      <el-col>
        <el-dropdown>
          <el-button type="primary">Add panel <i class="el-icon-arrow-down el-icon--right"></i></el-button>
          <el-dropdown-menu slot="dropdown">
            <el-dropdown-item v-for="panel in this.$data.panels" :key="panel.id">
              <div @click="createUserPanel({ panelId: panel.id })">{{panel.name}}</div>
            </el-dropdown-item>
          </el-dropdown-menu>
        </el-dropdown>
        <a href="/download" target="_blank" class="el-button el-button--primary">Download as PDF</a>
        <router-link to="/share" class="el-button el-button--primary">Send by email</router-link>
        <el-dropdown split-button type="primary">
          Overall
           <el-dropdown-menu slot="dropdown">
            <el-dropdown-item>Last 30 days</el-dropdown-item>
            <el-dropdown-item>Last 7 days</el-dropdown-item>
            <el-dropdown-item>Last 24 hours</el-dropdown-item>
          </el-dropdown-menu>
        </el-dropdown>
      </el-col>
    </el-row>

    <user-panels :data="this.$data.user_panels" :query="this.$apollo.queries.user_panels"></user-panels>
       
    <router-view></router-view>
  </el-main>
</template>

<script>
import gql from 'graphql-tag'
import UserPanelsComponent from '../components/user_panels'

export default {
  components: {
    'user-panels': UserPanelsComponent
  },

  apollo: {
    user_panels: {
      query: gql`{ currentUser { panels(sort: "position DESC") { id position panel(location: "home") { id name } } } }`,
      update({ currentUser: { panels }}) { return panels }
    },
    panels: {
      query: gql`{ panels(location: "home"){ id name } }`
    }
  },

  data() {
    return { panels: [], user_panels: [] }
  },

  methods: {
    setPanelHeight(event) {
      let iframe = event.target
      let iframeWin = iframe.contentWindow || iframe.contentDocument.parentWindow
      iframe.style.height = `${iframeWin.document.documentElement.scrollHeight || iframeWin.document.body.scrollHeight}px`
    },
    createUserPanel(userPanel) {
      console.log(userPanel)
      this.$apollo.mutate({
        mutation: gql`mutation ($userPanel: UserPanelInput!) {
          createUserPanel(userPanel: $userPanel) {
            success
            message
            errors { field message }
          }
        }`,
        variables: { userPanel: userPanel },
        update: (store, { data: { createUserPanel }}) => {
          if(createUserPanel.success) {
            this.$message.success('Panel added successfully')
            this.$apollo.queries.user_panels.refetch()
          }
          else 
            this.$message.error('Failed to add panel')
        }
      })
    }
  }
}
</script>
